<!DOCTYPE html>
<html lang="en-us">
<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="generator" content="Source Themes Academic 3.1.0">
  <meta name="generator" content="Hugo 0.50" />
  <meta name="author" content="Jeremy Jackson">

  
  
  
  
    
  
  <meta name="description" content="Working throught exercise 10 of chapter 3 in NodeJS.">

  
  <link rel="alternate" hreflang="en-us" href="https://ackso.net/project/exercises-for-programmers-4/">

  


  

  

  

  
  
  
  <meta name="theme-color" content="#2962ff">
  

  
  
  
  
    
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha256-eSi1q2PG6J7g7ib17yAaWMcrr5GrtohYChqibrV7PBE=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.8.6/css/academicons.min.css" integrity="sha256-uFVgMKfistnJAfoCUQigIl+JfUaP47GrRKjf6CTPVmw=" crossorigin="anonymous">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.css" integrity="sha256-ygkqlh3CYSUri3LhQxzdcm0n1EQvH2Y+U5S2idbLtxs=" crossorigin="anonymous">

    
    
    
      
    
    
      
      
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" crossorigin="anonymous">
      
    

    

    

  

  
  
  <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Montserrat:400,700|Roboto:400,400italic,700|Roboto+Mono">
  

  <link rel="stylesheet" href="/styles.css">
  

  
  
  

  
  <link rel="alternate" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  <link rel="feed" href="https://ackso.net/index.xml" type="application/rss+xml" title="Sometimes Jeremy Thinks">
  

  <link rel="manifest" href="/site.webmanifest">
  <link rel="icon" type="image/png" href="/img/icon.png">
  <link rel="apple-touch-icon" type="image/png" href="/img/icon-192.png">

  <link rel="canonical" href="https://ackso.net/project/exercises-for-programmers-4/">

  <meta property="twitter:card" content="summary_large_image">
  
  <meta property="og:site_name" content="Sometimes Jeremy Thinks">
  <meta property="og:url" content="https://ackso.net/project/exercises-for-programmers-4/">
  <meta property="og:title" content="Exercises for Programmers 4 - NODEJS | Sometimes Jeremy Thinks">
  <meta property="og:description" content="Working throught exercise 10 of chapter 3 in NodeJS.">
  
  
    
  <meta property="og:image" content="https://ackso.net/img/icon-192.png">
  <meta property="og:locale" content="en-us">
  
  <meta property="article:published_time" content="2018-01-05T21:14:35-07:00">
  
  <meta property="article:modified_time" content="2018-01-05T21:14:35-07:00">
  

  

  

  <title>Exercises for Programmers 4 - NODEJS | Sometimes Jeremy Thinks</title>

</head>
<body id="top" data-spy="scroll" data-target="#TableOfContents" data-offset="71" >

<nav class="navbar navbar-light fixed-top navbar-expand-lg py-0" id="navbar-main">
  <div class="container">

    
      <a class="navbar-brand" href="/">Sometimes Jeremy Thinks</a>
      
      <button type="button" class="navbar-toggler" data-toggle="collapse"
              data-target="#navbar" aria-controls="navbar" aria-expanded="false" aria-label="Toggle navigation">
        <span><i class="fas fa-bars"></i></span>
      </button>
      

    
    <div class="collapse navbar-collapse" id="navbar">

      
      
      <ul class="navbar-nav ml-auto">
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#about">
            
            <span>Home</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#posts">
            
            <span>Posts</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#projects">
            
            <span>Projects</span>
            
          </a>
        </li>

        
        

        

        
        
        
          
        

        <li class="nav-item">
          <a class="nav-link" href="/#contact">
            
            <span>Contact</span>
            
          </a>
        </li>

        
        

      

        

        
      </ul>

    </div>
  </div>
</nav>


<article class="article article-project" itemscope itemtype="http://schema.org/Article">

  












  

  
  
  
<div class="article-container pt-3">
  <h1 itemprop="name">Exercises for Programmers 4 - NODEJS</h1>

  

  
    

<div class="article-metadata">

  
  
  <span itemscope itemprop="author" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>
  

  <span class="article-date">
    
    <meta content="2018-01-05 21:14:35 -0700 MST" itemprop="datePublished">
    <time datetime="2018-01-05 21:14:35 -0700 MST" itemprop="dateModified">
      2018-01-05
    </time>
  </span>
  <span itemscope itemprop="publisher" itemtype="http://schema.org/Person">
    <meta itemprop="name" content="Jeremy Jackson">
  </span>

  

  
  
  <span class="middot-divider"></span>
  <a href="/project/exercises-for-programmers-4/#disqus_thread"></a>
  

  

  
  
<div class="share-box" aria-hidden="true">
  <ul class="share">
    <li>
      <a class="twitter"
         href="https://twitter.com/intent/tweet?text=Exercises%20for%20Programmers%204%20-%20NODEJS&amp;url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-4%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-twitter"></i>
      </a>
    </li>
    <li>
      <a class="facebook"
         href="https://www.facebook.com/sharer.php?u=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-4%2f"
         target="_blank" rel="noopener">
        <i class="fab fa-facebook-f"></i>
      </a>
    </li>
    <li>
      <a class="linkedin"
         href="https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-4%2f&amp;title=Exercises%20for%20Programmers%204%20-%20NODEJS"
         target="_blank" rel="noopener">
        <i class="fab fa-linkedin-in"></i>
      </a>
    </li>
    <li>
      <a class="weibo"
         href="http://service.weibo.com/share/share.php?url=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-4%2f&amp;title=Exercises%20for%20Programmers%204%20-%20NODEJS"
         target="_blank" rel="noopener">
        <i class="fab fa-weibo"></i>
      </a>
    </li>
    <li>
      <a class="email"
         href="mailto:?subject=Exercises%20for%20Programmers%204%20-%20NODEJS&amp;body=https%3a%2f%2fackso.net%2fproject%2fexercises-for-programmers-4%2f">
        <i class="fas fa-envelope"></i>
      </a>
    </li>
  </ul>
</div>


  

</div>

    















  
</div>



  <div class="article-container">

    <div class="article-style" itemprop="articleBody">
      

<p>As I mentioned in the previous post, chapter 3 is getting a bit more complex.
I&rsquo;m through Exercise 10, and that one ended up being pretty complex.
I ended up breaking out the functionality as lowly as I reasonably could
just to help control the complexity.
Part of the outcome of that is that I also had to write waaay more tests.
I&rsquo;m right around 750 lines in my chapter 3 test file, and around 225 of those
lines are just for this one exercise.</p>

<h2>Table of Contents</h2>
<nav id="TableOfContents">
<ul>
<li><a href="#working-up-the-functions-and-tests">Working up the functions and tests</a></li>
<li><a href="#dealing-with-user-input-and-eliminating-callback-hell">Dealing with user input and eliminating callback hell</a></li>
<li><a href="#things-i-would-change-for-the-future">Things I would change for the future</a></li>
<li><a href="#self-checkout-readline">Self Checkout <code>readline</code></a></li>
<li><a href="#self-checkout-fuctions">Self Checkout Fuctions</a></li>
</ul>
</nav>


<h1 id="working-up-the-functions-and-tests">Working up the functions and tests</h1>

<p>I ended up writing 7 functions for this exercise just to produce outputs,
most of which are fairly short and highly specific to their purpose.
For instance, rather than calculating a subtotal for an item as <code>price * quantity</code>
I converted it into a function call that does the math, but also takes care
of decimal precision.
Doing this for as many feature aspects as possible helped me keep my main
function that produces the final output fairly clean.
It also increased testability of each component piece so that I could
more easily test for edge cases.
So even though I ended up writing more tests and test cases, reasoning
about the tests and what the functions were supposed to do became <strong>much,
MUCH</strong> easier.</p>

<p>I also decided to break out some additional pieces of functionality that I
could see a lot of people leaving in the main function. One is responsibile for
deciding if a user input is valid.
It performs several tests to either throw one of three errors or return <code>true</code>.
Breaking this out and calling it as part of the main function let me keep
my <code>readline</code> functions a bit cleaner and also minimized the complexity of
generating errors from bad inputs.</p>

<p>The other function that others might have left in is responsible for building
the output string.
It takes numeric values calculated by other functions, sticks them in an array
of template strings, and then returns those strings joined together with
newline <code>\n</code> characters.</p>

<h1 id="dealing-with-user-input-and-eliminating-callback-hell">Dealing with user input and eliminating callback hell</h1>

<p>The last big takeaway I got from working through this exercise was in dealing
with user interaction via <code>readline</code>.
I had mentioned in one of the earlier Exercises for Programmers posts that
I was seeing a very strong possibilty of having to deal with callback hell
in working with <code>readline.question()</code>.
That hell almost became realized in working on this exercise.
The author has you asking two questions for each of three items: &ldquo;What&rsquo;s the
price?&rdquo; and &ldquo;What&rsquo;s the quantity?&rdquo;
This is an obvious situation where code re-use shows some benefits as well.
So between code re-use and the threat of callback hell I decided to pay
special attention to how this would interact with users and how I could
streamline and simplify my <code>readline</code>.</p>

<p>I considered several different possible courses of action, noting that
<code>readline</code> produces Streams, but after doing some reading into Streams,
Promises, and Generators (the three most likely places a solution for this
would come from) I settled on Promises as the correct way to handle this.
Since I have two questions, I wrote two functions that each returns
a <code>new Promise()</code> to ask them.
Since Promises can be chained together using the <code>then()</code> method, and the
output of each link in the chain is passed to the next <code>then()</code> call I
conveniently end up with a nice way to build up an Object piece by piece
that can ultimately be passed into my main funciton that I&rsquo;ve already written.</p>

<p>Each question also has to mention which &ldquo;item number&rdquo; it&rsquo;s asking about.
Since the book&rsquo;s requirements specify that we&rsquo;re only concerned about 3
items, and not a potentially infinite number, I decided that the most prudent
thing to do would be to explicitly chain all 6 questions together.
It also became simpler to just make the &ldquo;item number&rdquo; an argument to
the question functions.
This saved me from having to write code that would analyze the Object
passed into it in order to figure out what &ldquo;item number&rdquo; it would be
asking about.</p>

<h1 id="things-i-would-change-for-the-future">Things I would change for the future</h1>

<p>I think that how I&rsquo;m dealing with the <code>readline</code> functionality is really
good, but it could definitely be improved.
I currently don&rsquo;t have anything going on with the <code>reject</code> statements
in the Promises, mostly because I haven&rsquo;t given much thought about what
it would mean for possible future user input to be rejected.
In this case it may not be necessary.</p>

<p>I could also do more to clean up the input validation and error generation.
For instance, moving the input validation closer to the <code>readline</code>
statements would help in generating and recovering from errors earlier.
Currently it only has the possibility of generating errors after it has
already collected all of the information from the user.
I&rsquo;d like to throw the error sooner and also create a way to recover from
those errors and re-ask an errored question with some guidance to the
user about valid inputs.</p>

<p>Lastly, <code>selfCheckout()</code> has some ugly spots.
It works, but I wouldn&rsquo;t call it the most well-written and clear function
I&rsquo;ve ever written.
It could use a re-write, which could eventually turn into some of the
functionality built into it being pushed out to other functions.</p>

<h1 id="self-checkout-readline">Self Checkout <code>readline</code></h1>

<p>So here&rsquo;s my <code>readline</code> module that is implemented with Promises so
that we get that nice chaining to forward the data on to subsequent
questions.</p>

<pre><code class="language-javascript">#!/usr/bin/node

const readline = require('readline')
const { selfCheckout } = require('./ex10.js')

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout,
})

enterPrice({}, 1)
  .then(passedData =&gt; enterQty(passedData, 1))
  .then(passedData =&gt; enterPrice(passedData, 2))
  .then(passedData =&gt; enterQty(passedData, 2))
  .then(passedData =&gt; enterPrice(passedData, 3))
  .then(passedData =&gt; enterQty(passedData, 3))
  .then((passedData) =&gt; {
    const output = selfCheckout(passedData)
    console.log(output)
    rl.close()
  })

function enterPrice(passedData, itemNumber) {
  return new Promise((resolve, reject) =&gt; {
    rl.question(`Enter the price of item ${itemNumber}: `, (price) =&gt; {
      passedData[`item${itemNumber}`] = { price }
      resolve(passedData)
      reject()
    })
  })
}

function enterQty(passedData, itemNumber) {
  return new Promise((resolve, reject) =&gt; {
    rl.question(`Enter the quantity of item ${itemNumber}: `, (qty) =&gt; {
      passedData[`item${itemNumber}`].qty = qty
      resolve(passedData)
      reject()
    })
  })
}
</code></pre>

<h1 id="self-checkout-fuctions">Self Checkout Fuctions</h1>

<p>Here&rsquo;s all of the functions that do the calculations, validate inputs,
and generate outputs.
<code>selfCheckout()</code> is the function that brings all of them together and
gets called at the end of the <code>readline</code> Promise chain.</p>

<pre><code class="language-javascript">function itemSubtotal(price, qty) {
  const output = price * qty
  const output_fixed = output.toFixed(2)
  return output_fixed
}

function billSubtotal(subtotals) {
  const output = subtotals.reduce((arr, cv) =&gt; {
    arr += cv
    return arr
  }, 0)
  const output_fixed = output.toFixed(2)
  return output_fixed
}

function tax(subtotal) {
  const taxrate = 0.055
  const output = subtotal * taxrate
  const output_fixed = output.toFixed(2)
  return output_fixed
}

function total(subtotal, tax_val) {
  const output = subtotal + tax_val
  const output_fixed = output.toFixed(2)
  return output_fixed
}

function isStringedNumber(input, type) {
  if (!['money', 'quantity'].includes(type)) {
    throw new Error('type must be one of [\'money\', \'quantity\']')
  }

  if ((type === 'money' &amp;&amp; !/^[0-9]+(\.[0-9]{2})?$/.test(input)) || typeof input !== 'string') {
    throw new Error('price must be a string digit, either as an integer, or with two decimal places')
  }

  if ((type === 'quantity' &amp;&amp; !/^[0-9]+$/.test(input)) || typeof input !== 'string') {
    throw new Error('quantity must be a string integer')
  }

  return true
}

function outputBuilder(subtotal, tax_val, total_val) {
  const output = [
    `Subtotal: $${subtotal}`,
    `Tax: $${tax_val}`,
    `Total: $${total_val}`,
  ]

  return output.join('\n')
}

function selfCheckout(input) {
  const input_keys = Object.keys(input)
  input_keys.forEach((key) =&gt; {
    if (!['item1', 'item2', 'item3'].includes(key)) {
      throw new Error('input must be an object with three properties such that Object.keys(input) === [\'item1\', \'item2\', \'item3\']')
    }
  })
  if (!input_keys.includes('item1') || !input_keys.includes('item2') || !input_keys.includes('item3')) {
    throw new Error('input must be an object with three properties such that Object.keys(input) === [\'item1\', \'item2\', \'item3\']')
  }

  const input_vals = Object.values(input)
  input_vals.forEach((val) =&gt; {
    const val_keys = Object.keys(val)
    val_keys.forEach((key) =&gt; {
      if (!['price', 'qty'].includes(key)) {
        throw new Error('each item must have a price and qty and no other properties')
      }
    })
    if (!val_keys.includes('price') || !val_keys.includes('qty')) {
      throw new Error('each item must have a price and qty and no other properties')
    }

    isStringedNumber(val.price, 'money')
    isStringedNumber(val.qty, 'quantity')
  })

  const subtotals = [
    parseFloat(itemSubtotal(parseFloat(input.item1.price), parseFloat(input.item1.qty))),
    parseFloat(itemSubtotal(parseFloat(input.item2.price), parseFloat(input.item2.qty))),
    parseFloat(itemSubtotal(parseFloat(input.item3.price), parseFloat(input.item3.qty))),
  ]

  const billSub = billSubtotal(subtotals)
  const taxes = tax(parseFloat(billSub))
  const billTotal = total(parseFloat(billSub), parseFloat(taxes))

  const output = outputBuilder(billSub, taxes, billTotal)

  return output
}

module.exports = {
  selfCheckout,
  itemSubtotal,
  billSubtotal,
  tax,
  total,
  isStringedNumber,
  outputBuilder,
}
</code></pre>

    </div>

    


<div class="article-tags">
  
  <a class="badge badge-light" href="/tags/programming-exercises/">programming exercises</a>
  
  <a class="badge badge-light" href="/tags/nodejs/">nodejs</a>
  
</div>



    






<div class="media author-card" itemscope itemtype="http://schema.org/Person">
  
  <img class="portrait mr-3" src="/img/portrait.jpg" itemprop="image" alt="Avatar">
  
  <div class="media-body">
    <h5 class="card-title" itemprop="name"><a href="/">Jeremy Jackson</a></h5>
    <h6 class="card-subtitle">Software Engineering and Data Science</h6>
    
    <ul class="network-icon" aria-hidden="true">
      
      
      
      
      
      
      
      
      <li>
        <a itemprop="sameAs" href="mailto:jeremy_j@ackso.net" >
          <i class="fa fa-envelope"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//twitter.com/jeremy_j_ackso" >
          <i class="fab fa-twitter"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//github.com/jeremy-j-ackso" >
          <i class="fab fa-github"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//gitlab.com/jeremy.jackson" >
          <i class="fab fa-gitlab"></i>
        </a>
      </li>
      
      
      
      
        
      
      
      
      
      
        
      
      <li>
        <a itemprop="sameAs" href="//linkedin.com/in/jeremy-jackson-249878153" >
          <i class="fab fa-linkedin"></i>
        </a>
      </li>
      
    </ul>
  </div>
</div>




    
    
    
    
    
    
    

    

      
      
      

      
      
      
      

      
      
      
      
    

  </div>
</article>



<div class="container">
  <footer class="site-footer">
  

  <p class="powered-by">
    &copy; 2017 Jeremy T Jackson &middot; 

    Powered by the
    <a href="https://sourcethemes.com/academic/" target="_blank" rel="noopener">Academic theme</a> for
    <a href="https://gohugo.io" target="_blank" rel="noopener">Hugo</a>.

    
    <span class="float-right" aria-hidden="true">
      <a href="#" id="back_to_top">
        <span class="button_icon">
          <i class="fas fa-chevron-up fa-2x"></i>
        </span>
      </a>
    </span>
    
  </p>
</footer>

</div>


<div id="modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Cite</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <pre><code class="tex hljs"></code></pre>
      </div>
      <div class="modal-footer">
        <a class="btn btn-outline-primary my-1 js-copy-cite" href="#" target="_blank">
          <i class="fas fa-copy"></i> Copy
        </a>
        <a class="btn btn-outline-primary my-1 js-download-cite" href="#" target="_blank">
          <i class="fas fa-download"></i> Download
        </a>
        <div id="modal-error"></div>
      </div>
    </div>
  </div>
</div>

    

    
    
    
    
    <script src="/js/mathjax-config.500a6cbb2c0f345fcecc21b3116d6637aa78f1f11db8081ea581abe05390c2e8f3bbffe61be3cf0217baf785c40efceabe51050a4f007e69af94efd3643260e8.js" integrity="sha512-UApsuywPNF/OzCGzEW1mN6p48fEduAgepYGr4FOQwujzu//mG&#43;PPAhe694XEDvzqvlEFCk8AfmmvlO/TZDJg6A=="></script>
    

    
    
    
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha512-+NqPlbbtM1QqiK8ZAo4Yrj2c4lNQoGv8P79DPtKzj++l5jnN39rHA/xsqn8zE9l0uSoxaCdrOgFs6yjyfbBxSg==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.imagesloaded/4.1.3/imagesloaded.pkgd.min.js" integrity="sha512-umsR78NN0D23AzgoZ11K7raBD+R6hqKojyBZs1w8WvYlsI+QuKRGBx3LFCwhatzBunCjDuJpDHwxD13sLMbpRA==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha256-VsEqElsCHSGmnmHXGQzvoWjWwoznFSZc6hs7ARLRacQ=" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.isotope/3.0.4/isotope.pkgd.min.js" integrity="sha512-VDBOIlDbuC4VWxGJNmuFRQ0Li0SKkDpmGyuhAG5LTDLd/dJ/S0WMVxriR2Y+CyPL5gzjpN4f/6iqWVBJlht0tQ==" crossorigin="anonymous"></script>
      <script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.2.5/jquery.fancybox.min.js" integrity="sha256-X5PoE3KU5l+JcX+w09p/wHl9AzK333C4hJ2I9S5mD4M=" crossorigin="anonymous"></script>

      
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js" integrity="sha256-/BfiIkHlHoVihZdc6TFuj7MmJ0TWcWsMXkeDFwhi0zw=" crossorigin="anonymous"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/python.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/r.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/bash.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/css.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/diff.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/javascript.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/json.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/markdown.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/nginx.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/processing.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/scala.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/sql.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/tex.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/vim.min.js"></script>
        
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/yaml.min.js"></script>
        
      

      
      
      <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-AMS_CHTML-full" integrity="sha256-GhM+5JHb6QUzOQPXSJLEWP7R73CbkisjzK5Eyij4U9w=" crossorigin="anonymous" async></script>
      
    

    <script src="/js/hugo-academic.js"></script>
    

    
    

    
    
    
    <script id="dsq-count-scr" src="//ackso-net.disqus.com.disqus.com/count.js" async></script>
    

    
    
    <script>hljs.initHighlightingOnLoad();</script>
    

    
    
    <script>
      const search_index_filename = "/index.json";
      const i18n = {
        'placeholder': "Search...",
        'results': "Search Results",
        'no_results': "No results found"
      };
      const content_type = {
        'post': "Posts",
        'project': "Projects",
        'publication' : "Publications",
        'talk' : "Talks"
        };
    </script>
    

    
    

    

    
    

    
    

  </body>
</html>

